.386
.model flat,stdcall
option casemap:none

include windows.inc
include kernel32.inc
include user32.inc
include comctl32.inc
include comdlg32.inc


includelib kernel32.lib
includelib user32.lib
includelib comctl32.lib
includelib comdlg32.lib


DialogProc proto :DWORD,:DWORD,:DWORD,:DWORD
OpenDialogProc proto :DWORD

.data
AppName db "Test Window",0
szFilter db "All files (*.*)",0,"*.*",0,0
szCaption db "Open File",0

.data?
CommandLine LPSTR ?
hInstance HINSTANCE ?
hButton HWND ?

.const
IDD_DLG equ 1000
IDC_BTN equ 1001

.code
Start:
    invoke GetModuleHandle,NULL         
    mov hInstance,eax                   
    invoke GetCommandLine               
    mov CommandLine,eax   
    ;invoke InitCommonControls              
    invoke DialogBoxParam,hInstance,IDD_DLG,NULL,addr DialogProc,NULL
    invoke ExitProcess,eax             

DialogProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG

	.elseif eax==WM_COMMAND
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		.if edx==BN_CLICKED
			.if eax==IDC_BTN
				invoke OpenDialogProc,hWin
			.endif
		.endif
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,NULL
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DialogProc endp
OpenDialogProc proc hwnd:HWND
	
LOCAL opf:OPENFILENAME
LOCAL szFileName[256]:BYTE
LOCAL szFileTitle[256]:BYTE

	mov opf.lStructSize,sizeof OPENFILENAME
	lea ebx,szFileName
	invoke RtlZeroMemory,ebx,256
	mov opf.lpstrFile,ebx
	mov opf.nMaxFile,255
	lea ebx,szFileTitle
	mov opf.lpstrFileTitle,ebx
	mov opf.nMaxFileTitle,255
	mov opf.lpstrFilter,offset szFilter
	push hInstance
	pop opf.hInstance
	push hwnd
	pop opf.hwndOwner
	mov opf.lpstrTitle,offset szCaption
	mov opf.Flags,OFN_EXPLORER Or OFN_HIDEREADONLY
	invoke GetOpenFileName,addr opf
	ret

OpenDialogProc endp

end Start
