.386
.model flat,stdcall
option casemap:none

include windows.inc
include kernel32.inc
include user32.inc
include comctl32.inc
include comdlg32.inc


includelib kernel32.lib
includelib user32.lib
includelib comctl32.lib
includelib comdlg32.lib


WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
OpenDialogProc proto :DWORD

.data
ClassName db "SimpleWinClass",0
AppName db "Test Window",0
ButtonText db "Push",0
szFilter db "All files (*.*)",0,"*.*",0,0
szCaption db "Open File",0
BUTTON db "BUTTON",0


.data?
CommandLine LPSTR ?
hInstance HINSTANCE ?
hButton HWND ?

.code
Start:
    invoke GetModuleHandle,NULL         
    mov hInstance,eax                   
    invoke GetCommandLine               
    mov CommandLine,eax   
    ;invoke InitCommonControls              
    invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT    
    invoke ExitProcess,eax             

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND

    mov wc.cbSize, SIZEOF WNDCLASSEX
	mov wc.style, CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS
    mov wc.lpfnWndProc, offset WndProc
    mov wc.cbClsExtra, NULL
    mov wc.cbWndExtra, NULL
    push hInstance
    pop wc.hInstance
    invoke LoadIcon,NULL,IDI_APPLICATION
    mov wc.hIcon, eax
    mov wc.hIconSm, eax
    invoke LoadCursor, NULL, IDC_ARROW
    mov wc.hCursor, eax
    mov wc.hbrBackground,COLOR_BTNFACE+1
    mov wc.lpszMenuName, NULL
    mov wc.lpszClassName, offset ClassName
    invoke RegisterClassEx, addr wc
    invoke CreateWindowEx, NULL, addr ClassName, addr AppName,WS_CAPTION or WS_SYSMENU, CW_USEDEFAULT, CW_USEDEFAULT, 450, 150, NULL, NULL, hInst, NULL
    mov hwnd, eax
     
    invoke ShowWindow, hwnd, CmdShow
    invoke UpdateWindow, hwnd
    .while TRUE
        invoke GetMessage, addr msg, NULL, 0, 0
        .break .if(!eax)
        invoke TranslateMessage, addr msg
        invoke DispatchMessage, addr msg
    .endw

    mov eax, msg.wParam
    ret
WinMain endp

WndProc proc hwnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

LOCAL hFont:HFONT
LOCAL hInst:HINSTANCE


    .if uMsg==WM_DESTROY
        invoke PostQuitMessage, NULL
    .elseif uMsg==WM_CREATE
    	invoke SetWindowText,hwnd,addr AppName
    	invoke CreateWindowEx,NULL,addr BUTTON,addr ButtonText,WS_VISIBLE or WS_CHILD or BS_PUSHBUTTON,25,70,400,30,hwnd,NULL,hInstance,NULL
    	mov hButton,eax
    .elseif uMsg==WM_COMMAND
    	mov ebx,lParam
    	.if ebx==hButton
    		invoke OpenDialogProc,hwnd
    	.endif
    .else
        invoke DefWindowProc, hwnd, uMsg, wParam, lParam
        ret
    .endif
    xor eax, eax
    ret
WndProc endp

OpenDialogProc proc hwnd:HWND
	
LOCAL opf:OPENFILENAME
LOCAL szFileName[256]:BYTE
LOCAL szFileTitle[256]:BYTE

	mov opf.lStructSize,sizeof OPENFILENAME
	lea ebx,szFileName
	invoke RtlZeroMemory,ebx,256
	mov opf.lpstrFile,ebx
	mov opf.nMaxFile,255
	lea ebx,szFileTitle
	mov opf.lpstrFileTitle,ebx
	mov opf.nMaxFileTitle,255
	mov opf.lpstrFilter,offset szFilter
	push hInstance
	pop opf.hInstance
	push hwnd
	pop opf.hwndOwner
	mov opf.lpstrTitle,offset szCaption
	mov opf.Flags,OFN_EXPLORER Or OFN_HIDEREADONLY
	invoke GetOpenFileName,addr opf
	ret

OpenDialogProc endp

end Start
